#!/usr/bin/env python
"""
C extensions call this function via the document_helper functions to get their
doc strings at run time. They pass a string describing the object. A attribute
for the string is searched here and returned.
"""
import exceptions

class _qrng:
    """    
     A quasi-random sequence progressively covers a d-dimensional space with a
     set of points that are uniformly distributed.  Quasi-random sequences are
     also  known  as  low-discrepancy  sequences.  The  quasi-random  sequence
     generators use an  interface that is similar to  the interface for random
     number generators.

    Setup:
    
    """
    class PyGSL_qrng_type:
        """
        Encapsulation of the gsl_qrng_type. Pass to qrng to generate a
        quasi random distribution.
        """
    class PyGSL_qrng:
        """
        Encapsulation of a gsl_rng. Pass to qrng to generate a
        quasi random distribution.
        """

    class niederreiter_2:
        """
        This generator uses the algorithm described in Bratley, Fox,
        Niederreiter, `ACM Trans. Model. Comp. Sim.' 2, 195 (1992). It is
        valid up to 12 dimensions.
        """
    class sobol:
        """
        This generator uses the Sobol sequence described in Antonov,
        Saleev, `USSR Comput. Maths. Math. Phys.' 19, 252 (1980). It is
        valid up to 40 dimensions.
        """

def add_doc_strings(string):
    #print "Searching description for -->%s<--" % string
    ret = ""
    test = 0
    try:
        tmp = eval(string);
        ret = str(tmp.__doc__)
        test = 1
    except exceptions.Exception, des:
        if test == 0:
            #print "Failure getting string %s. Reason %s" %(string, des)
    return ret



