static PyObject *
PyGSL_set_debug_level(PyObject *self, PyObject *args)
{
#if DEBUG == 1
     int tmp;
     if(!PyArg_ParseTuple(args, "i", &tmp))
	  return NULL;
     if(tmp >= 0 && tmp <PyGSL_DEBUG_MAX)
	  PyGSL_API[PyGSL_debug_level_NUM] = (void *) tmp;
     else
	  GSL_ERROR_VAL("Only accept debug levels between 0 and PyGSL_DEBUG_MAX", GSL_EINVAL, NULL);
     Py_INCREF(Py_None);
     return Py_None;
#else 
     GSL_ERROR_VAL("PyGSL was not compiled with DEBUG = 1; Can not set DEBUG level!", GSL_EUNIMPL, NULL);
#endif 
}

static PyObject *
PyGSL_get_debug_level(PyObject *self, PyObject *args)
{
     int tmp;
#if DEBUG == 1
     tmp = (int) PyGSL_API[PyGSL_debug_level_NUM];
#else 
     tmp = DEBUG;
#endif 
     return PyInt_FromLong(tmp);
}
